/*
	This file contains the entry point (Reset_Handler) of your firmware project.
	The reset handled initializes the RAM and calls system library initializers as well as
	the platform-specific initializer and the main() function.
*/

extern void *_estack;

#define NULL ((void *)0)

void Reset_Handler();
void Default_Handler();

#ifdef DEBUG_DEFAULT_INTERRUPT_HANDLERS
void __attribute__ ((weak)) NMI_Handler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void NMI_Handler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) HardFault_Handler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void HardFault_Handler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) MemManage_Handler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void MemManage_Handler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) BusFault_Handler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void BusFault_Handler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) UsageFault_Handler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void UsageFault_Handler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) SVC_Handler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void SVC_Handler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) DebugMon_Handler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void DebugMon_Handler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) PendSV_Handler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void PendSV_Handler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) SysTick_Handler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void SysTick_Handler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) EMU_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void EMU_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) WDOG0_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void WDOG0_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) LDMA_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void LDMA_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) GPIO_EVEN_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void GPIO_EVEN_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) TIMER0_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void TIMER0_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) USART0_RX_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void USART0_RX_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) USART0_TX_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void USART0_TX_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) ACMP0_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void ACMP0_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) ADC0_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void ADC0_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) IDAC0_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void IDAC0_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) I2C0_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void I2C0_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) GPIO_ODD_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void GPIO_ODD_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) TIMER1_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void TIMER1_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) USART1_RX_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void USART1_RX_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) USART1_TX_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void USART1_TX_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) LEUART0_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void LEUART0_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) PCNT0_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void PCNT0_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) CMU_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void CMU_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) MSC_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void MSC_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) CRYPTO_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void CRYPTO_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) LETIMER0_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void LETIMER0_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) RTCC_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void RTCC_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) CRYOTIMER_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void CRYOTIMER_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) FPUEH_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void FPUEH_IRQHandler();
	asm("bkpt 255");
}

#else
void NMI_Handler()           __attribute__ ((weak, alias ("Default_Handler")));
void HardFault_Handler()     __attribute__ ((weak, alias ("Default_Handler")));
void MemManage_Handler()     __attribute__ ((weak, alias ("Default_Handler")));
void BusFault_Handler()      __attribute__ ((weak, alias ("Default_Handler")));
void UsageFault_Handler()    __attribute__ ((weak, alias ("Default_Handler")));
void SVC_Handler()           __attribute__ ((weak, alias ("Default_Handler")));
void DebugMon_Handler()      __attribute__ ((weak, alias ("Default_Handler")));
void PendSV_Handler()        __attribute__ ((weak, alias ("Default_Handler")));
void SysTick_Handler()       __attribute__ ((weak, alias ("Default_Handler")));
void EMU_IRQHandler()        __attribute__ ((weak, alias ("Default_Handler")));
void WDOG0_IRQHandler()      __attribute__ ((weak, alias ("Default_Handler")));
void LDMA_IRQHandler()       __attribute__ ((weak, alias ("Default_Handler")));
void GPIO_EVEN_IRQHandler()  __attribute__ ((weak, alias ("Default_Handler")));
void TIMER0_IRQHandler()     __attribute__ ((weak, alias ("Default_Handler")));
void USART0_RX_IRQHandler()  __attribute__ ((weak, alias ("Default_Handler")));
void USART0_TX_IRQHandler()  __attribute__ ((weak, alias ("Default_Handler")));
void ACMP0_IRQHandler()      __attribute__ ((weak, alias ("Default_Handler")));
void ADC0_IRQHandler()       __attribute__ ((weak, alias ("Default_Handler")));
void IDAC0_IRQHandler()      __attribute__ ((weak, alias ("Default_Handler")));
void I2C0_IRQHandler()       __attribute__ ((weak, alias ("Default_Handler")));
void GPIO_ODD_IRQHandler()   __attribute__ ((weak, alias ("Default_Handler")));
void TIMER1_IRQHandler()     __attribute__ ((weak, alias ("Default_Handler")));
void USART1_RX_IRQHandler()  __attribute__ ((weak, alias ("Default_Handler")));
void USART1_TX_IRQHandler()  __attribute__ ((weak, alias ("Default_Handler")));
void LEUART0_IRQHandler()    __attribute__ ((weak, alias ("Default_Handler")));
void PCNT0_IRQHandler()      __attribute__ ((weak, alias ("Default_Handler")));
void CMU_IRQHandler()        __attribute__ ((weak, alias ("Default_Handler")));
void MSC_IRQHandler()        __attribute__ ((weak, alias ("Default_Handler")));
void CRYPTO_IRQHandler()     __attribute__ ((weak, alias ("Default_Handler")));
void LETIMER0_IRQHandler()   __attribute__ ((weak, alias ("Default_Handler")));
void RTCC_IRQHandler()       __attribute__ ((weak, alias ("Default_Handler")));
void CRYOTIMER_IRQHandler()  __attribute__ ((weak, alias ("Default_Handler")));
void FPUEH_IRQHandler()      __attribute__ ((weak, alias ("Default_Handler")));
#endif

void * g_pfnVectors[0x32] __attribute__ ((section (".isr_vector"))) = 
{
	&_estack,
	&Reset_Handler,
	&NMI_Handler,
	&HardFault_Handler,
	&MemManage_Handler,
	&BusFault_Handler,
	&UsageFault_Handler,
	NULL,
	NULL,
	NULL,
	NULL,
	&SVC_Handler,
	&DebugMon_Handler,
	NULL,
	&PendSV_Handler,
	&SysTick_Handler,
	&EMU_IRQHandler,
	NULL,
	&WDOG0_IRQHandler,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	&LDMA_IRQHandler,
	&GPIO_EVEN_IRQHandler,
	&TIMER0_IRQHandler,
	&USART0_RX_IRQHandler,
	&USART0_TX_IRQHandler,
	&ACMP0_IRQHandler,
	&ADC0_IRQHandler,
	&IDAC0_IRQHandler,
	&I2C0_IRQHandler,
	&GPIO_ODD_IRQHandler,
	&TIMER1_IRQHandler,
	&USART1_RX_IRQHandler,
	&USART1_TX_IRQHandler,
	&LEUART0_IRQHandler,
	&PCNT0_IRQHandler,
	&CMU_IRQHandler,
	&MSC_IRQHandler,
	&CRYPTO_IRQHandler,
	&LETIMER0_IRQHandler,
	NULL,
	NULL,
	&RTCC_IRQHandler,
	NULL,
	&CRYOTIMER_IRQHandler,
	NULL,
	&FPUEH_IRQHandler,
};

void SystemInit();
void __libc_init_array();
int main();

extern void *_sidata, *_sdata, *_edata;
extern void *_sbss, *_ebss;

void __attribute__((naked, noreturn)) Reset_Handler()
{
	//Normally the CPU should will setup the based on the value from the first entry in the vector table.
	//If you encounter problems with accessing stack variables during initialization, ensure the line below is enabled.
	#ifdef sram_layout
	asm ("ldr sp, =_estack");
	#endif

	void **pSource, **pDest;
	for (pSource = &_sidata, pDest = &_sdata; pDest != &_edata; pSource++, pDest++)
		*pDest = *pSource;

	for (pDest = &_sbss; pDest != &_ebss; pDest++)
		*pDest = 0;

	SystemInit();
	__libc_init_array();
	(void)main();
	for (;;) ;
}

void __attribute__((naked, noreturn)) Default_Handler()
{
	//If you get stuck here, your code is missing a handler for some interrupt.
	//Define a 'DEBUG_DEFAULT_INTERRUPT_HANDLERS' macro via VisualGDB Project Properties and rebuild your project.
	//This will pinpoint a specific missing vector.
	for (;;) ;
}
